/*
 * Author: Kostas Kostiadis
 * Description: Contains all the member function implementations of the CFlag class
 * 				The CFlag class holds information regarding a flag on the field.
 * Created: 14/12/98
 * Last modified: 12/7/99
 */

#include <iostream.h> 
#include "CFlag.H"

// Default constructor //////////////////////////////////////////////////
CFlag::CFlag()
{
}

// Default destructor ////////////////////////////////////////////////////
CFlag::~CFlag()
{
}

// INIT ////////////////////////////////////////////////////////////////
void CFlag::Init(int ID, float GX, float GY, float StatConfThr)	// Used to initialise flags.  Just sets the ID and global (X,Y), and all other variables to 0.
{
m_ID = ID;
m_Time = -999;
m_RPos = CVector(0, 0);
m_DistChng = 0.0;
m_DirChng = 0.0;
m_Conf = 0.0;

m_GPos = CVector(GX, GY);
m_StatConfThr = StatConfThr;
}

// REVERTSIGNS ////////////////////////////////////////////////////////
void CFlag::RevertSigns()					// Revert signs for right side players
{
m_GPos = CVector(-m_GPos.GetX(), -m_GPos.GetY());
}
 
// DISPLAY /////////////////////////////////////////////////////////////////
void CFlag::Display() const	// Displays all params.  Just for debugging
{
cout << "\tFLAG ID: " << m_ID << endl;
cout << "\tFLAG Time:" << m_Time << endl;
cout << "\tFLAG RDist: " << m_RPos.GetMag() << endl;
cout << "\tFLAG RDir: " << m_RPos.GetDir() << endl;
cout << "\tFLAG Conf: " << m_Conf << endl;
cout << "\tFLAG GX: " << m_GPos.GetX() << endl;
cout << "\tFLAG GY: " << m_GPos.GetY() << endl;
}

// UPDATERPOS ///////////////////////////////////////////////////////////////
void CFlag::UpdateRPos(CVector GPos, float GFacing, int Time)	// Update flag's relative position
{
if (m_Time < Time)									// If object not seen NOW
	{
	m_RPos = m_GPos - GPos;							// Update it's relative position
	m_RPos = m_RPos.Rotate(-GFacing);
	m_Time = Time;
	}
}
