/*
 * Author: Kostas Kostiadis
 * Description: Contains all the member function implementations of the CGoal class
 * 				The CGoal class holds information regarding a goal on the field.
 * Created: 14/12/98
 * Last modified: 12/7/99
 */
 
#include <iostream.h>
#include "CGoal.H"

// Default constructor /////////////////////////////////////////////////////
CGoal::CGoal()
{
}

// Default destructor /////////////////////////////////////////////////////
CGoal::~CGoal()
{
}

// INIT ///////////////////////////////////////////////////////////////////
void CGoal::Init(char ID, float GX, float GY, float StatConfThr)	// Used to initialise goals.  Just sets the ID and global (X,Y), and all other variables to 0.
{
m_ID = ID;			// Goal ID: 0-left, 1-right
m_Time = -999;
m_RPos = CVector(0, 0);
m_Conf = 0.0;

m_GPos = CVector(GX, GY);
m_StatConfThr = StatConfThr;
}

// REVERTSIGNS ////////////////////////////////////////////////////////
void CGoal::RevertSigns()					// Revert signs for right side players
{
m_GPos = CVector(-m_GPos.GetX(), -m_GPos.GetY());
}
 
// DISPLAY ////////////////////////////////////////////////////////////////
void CGoal::Display() const	// Displays all params.  Just for debugging
{
cout << "\tGOAL ID: " << m_ID << endl;
cout << "\tGOAL Time:" << m_Time << endl;
cout << "\tGOAL RDist: " << m_RPos.GetMag() << endl;
cout << "\tGOAL RDir: " << m_RPos.GetDir() << endl;
cout << "\tGOAL Conf: " << m_Conf << endl;
cout << "\tGOAL GX: " << m_GPos.GetX() << endl;
cout << "\tGOAL GY: " << m_GPos.GetY() << endl;
}

// UPDATERPOS ///////////////////////////////////////////////////////////////
void CGoal::UpdateRPos(CVector GPos, float GFacing, int Time)	// Update goal's relative position
{
if (m_Time < Time)									// If object not seen NOW
	{
	m_RPos = m_GPos - GPos;							// Update it's relative position
	m_RPos = m_RPos.Rotate(-GFacing);
	m_Time = Time;
	}
}
