/*
 * Author: Kostas Kostiadis
 * Description: Contains all the member function implementations of the CLine class
 * 				The CLine class holds information regarding a line on the field.
 * Created: 14/12/98
 * Last modified: 12/7/99
 */

#include <iostream.h> 
#include "CLine.H"

// Default constructor /////////////////////////////////////////////////////////
CLine::CLine()
{
}

// Default destructor //////////////////////////////////////////////////////////
CLine::~CLine()
{
}

// INIT ///////////////////////////////////////////////////////////////////////
void CLine::Init(char ID, float GX, float GY, float StatConfThr)	// Used to initialise lines.  Just sets the ID, and all other variables to 0.
{
m_ID = ID;					// Line ID: l, r, t, b
m_Time = -999;
m_RPos = CVector(0, 0);
m_Conf = 0.0;

m_GPos = CVector(GX, GY);
m_StatConfThr = StatConfThr;
}

// REVERTSIGNS ////////////////////////////////////////////////////////
void CLine::RevertSigns()					// Revert signs for right side players
{
m_GPos = CVector(-m_GPos.GetX(), -m_GPos.GetY());
}

// DISPLAY //////////////////////////////////////////////////////////////////
void CLine::Display() const	// Displays all params.  Just for debugging
{
cout << "\tLINE ID: " << m_ID << endl;
cout << "\tLINE Time:" << m_Time << endl;
cout << "\tLINE RDist: " << m_RPos.GetMag() << endl;
cout << "\tLINE RDir: " << m_RPos.GetDir() << endl;
cout << "\tLINE Conf: " << m_Conf << endl;
}

// UPDATERPOS ///////////////////////////////////////////////////////////////
void CLine::UpdateRPos(CVector GPos, float GFacing, int Time)	// Update line's relative position
{
if (m_Time < Time)									// If object not seen NOW
	{
	m_RPos = m_GPos - GPos;							// Update it's relative position
	m_RPos = m_RPos.Rotate(-GFacing);
	m_Time = Time;
	}
}
