/*
 * Author: Kostas Kostiadis
 * Description: Contains all the member function implementations of the CPlayer class
 * 				The CPlayer class holds information regarding a player on the field.
 * Created: 14/12/98
 * Last modified: 12/7/98
 */

#include <iostream.h> 
#include "CPlayer.H"

// Default constructor //////////////////////////////////
CPlayer::CPlayer()
{
}

// Default destructor ///////////////////////////////////
CPlayer::~CPlayer()
{
}

// INIT /////////////////////////////////////////////////
// Used to initialise players
void CPlayer::Init(int UNum, int Side, float Size, float Decay, float Rand, float Weight, float SpeedMax, float MobConfThr)
{
m_UNum = UNum;							// Just sets the UNum and Side, and all other variables to 0.
m_Side = Side;

m_Size = Size;
m_Decay = Decay;
m_Rand = Rand;
m_Weight = Weight;
m_SpeedMax = SpeedMax;
m_MobConfThr = MobConfThr;

m_Time = -999;
m_RPos = CVector(0, 0);
m_DistChng = 0.0;
m_DirChng = 0.0;
m_RFacing = 0.0;
m_Conf = 0.0;

m_GPos = CVector(0, 0);
m_GFacing = 0.0;

m_Velocity = CVector(0, 0);
m_VelocityValid = 0;
m_PositionValid = 0;
}
 
// DISPLAY ///////////////////////////////////////////////
void CPlayer::Display() const	// Displays all params.  Just for debugging
{
cout << "\tPLAYER UNum: " << m_UNum << endl;
cout << "\tPLAYER Side: " << m_Side << endl;
cout << "\tPLAYER Time: " << m_Time << endl;
cout << "\tPLAYER RDist: " << m_RPos.GetMag() << endl;
cout << "\tPLAYER RDir: " << m_RPos.GetDir() << endl;
cout << "\tPLAYER RFacing: " << m_RFacing << endl;
cout << "\tPLAYER Conf: " << m_Conf << endl;
cout << "\tPLAYER GX: " << m_GPos.GetX() << endl;
cout << "\tPLAYER GY: " << m_GPos.GetY() << endl;
cout << "\tPLAYER GFacing: " << m_GFacing << endl;
cout << "\tPLAYER VX: " << m_Velocity.GetX() << endl;
cout << "\tPLAYER VY: " << m_Velocity.GetY() << endl;
cout << "\tPLAYER Mag: " << m_Velocity.GetMag() << endl;
cout << "\tPLAYER Dir: " << m_Velocity.GetDir() << endl;
cout << "\tPLAYER VelocityValid: " << m_VelocityValid << endl;
cout << "\tPLAYER PositionValid: " << m_PositionValid << endl;
}

// UPDATERPOS ///////////////////////////////////////////////////////////////
void CPlayer::UpdateRPos(CVector GPos, float GFacing, int Time)		// Update player's relative position
{
/*
	Both these tests are necessary here (rather than just the time test)
	because the looking at behaviours might oscilate doing 80, -80, 80...and so
	on turns trying to locate an object
*/

if ((m_Time < Time) && (m_Conf > m_MobConfThr))			// If object remembered but not seen NOW
	{
	m_RPos = m_GPos - GPos;
	m_RPos = m_RPos.Rotate(-GFacing);
	m_Time = Time;
	}
}
