/*
 * Author: Kostas Kostiadis
 * Description: Contains the necessary functions that allow pthread_create
 *				for a member function.
 * Created: 17/12/98
 * Last modified: 15/6/99
 */

#include <iostream.h>
#include "../Agent_Classes/CSensors.H"
#include "../Agent_Classes/CActuators.H"

/* 
 *	pthread_create takes a pointer to a C function.
 *	Hence to call pthread_create with a member function of a
 *	class, we need to have a C function that somehow points to
 *	our member funciton...so here it goes
 */

// SENSORTHRED //////////////////////////////////////////////////
extern "C" void *StartSensors(void *arg)
{
cout << "Starting SENSORS thread..." << endl;
CSensors *obj = (CSensors *) arg;
obj->SensorThread();
}

extern "C" void *StartActuators(void *arg)
{
cout << "Starting ACTUATORS thread..." << endl;
CActuators *obj = (CActuators *) arg;
obj->ActuatorThread();
}
