/*
 * Author: Kostas Kostiadis
 * Description: Contains all the global co-ordinates for each player depending on the formation
 * Created: 17/3/99
 * Last modified: 23/7/99
 */

#ifndef _FORMATIONS_H
#define _FORMATIONS_H

#include "Formations.H"

// 3-3-4 LOSING FORMATION ///////////////////////////////////////
int ThreeThreeFour[11][2] = {	// 3-3-4 positioning
	{-50,		0},				// Goalie
	{-30,		-20},			// Left Back
	{-30,		0},				// Centre Back
	{-30,		20},			// Right Back
	{0,			-15},			// Left Mid
	{0,			0},				// Centre Mid
	{0,			15},			// Right Mid
	{17,		-25},			// Left Wing
	{27,		-7},			// Left Forward
	{27,		7},				// Right Forward
	{17,		25},			// Right Wing
};

// 4-3-3 NORMAL FORMATION ////////////////////////////////////////
int FourThreeThree[11][2] = {	// 4-3-3 formation
	{-50,		0},			// Goalie
	{-40,		0},			// Sweeper
	{-30,		-25},		// Left Back
	{-30,		0},			// Center Back
	{-30,		25},		// Right Back
	{0,			-15},		// Left Mid
	{0,			0},			// Center Mid
	{0,			15},		// Right Mid
	{27,		-25},		// Left Wing
	{27,		0},			// Center Forward
	{27,		25},		// Right Wing
};

// 5-3-2 WINNING FORMATION /////////////////////////////////////////////////
int FiveThreeTwo[11][2] = {	// 5-3-2 positioning
	{-50,		0},			// Goalie
	{-30,		-20},		// Left Half-Back
	{-40,		-10},		// Left Back
	{-30,		0},			// Cetre Back
	{-40,		10},		// Right Back
	{-30,		20},		// Right Half-Back
	{-5,		-15},		// Left Mid
	{-5,		0},			// Centre Mid
	{-5,		15},		// Right Mid
	{20,		-10},		// Left Forward
	{20,		10},		// Right Forward
};
	
// Stop clearance formations
// 3-3-4 LOSING FORMATION STOP CLEARANCE //////////////////////////////
int ThreeThreeFourSC[11][2] = {	// 3-3-4 positioning
	{-50,		0},				// Goalie
	{-2,		-25},			// Left Back
	{-2,		0},				// Centre Back
	{-2,		25},			// Right Back
	{15,		-23},			// Left Mid
	{15,		0},				// Centre Mid
	{15,		23},			// Right Mid
	{30,		-20},			// Left Wing
	{30,		-7},			// Left Forward
	{30,		7},				// Right Forward
	{30,		20},			// Right Wing
};

// 4-3-3 NORMAL FORMATION STOP CLEARANCE ///////////////////////////
int FourThreeThreeSC[11][2] = {	// 4-3-3 formation
	{-50,		0},			// Goalie
	{-2,		-10},		// Sweeper
	{-2,		-25},		// Left Back
	{-2,		10},		// Center Back
	{-2,		25},		// Right Back
	{15,		-23},		// Left Mid
	{15,		0},			// Center Mid
	{15,		23},		// Right Mid
	{30,		-9},		// Left Wing
	{30,		0},			// Center Forward
	{30,		9},			// Right Wing
};

// 5-3-2 WINNING FORMATION STOP CLEARANCE ////////////////////////////
int FiveThreeTwoSC[11][2] = {	// 5-3-2 positioning
	{-50,		0},			// Goalie
	{-2,		-25},		// Left Half-Back
	{-2,		-10},		// Left Back
	{-5,		0},			// Cetre Back
	{-2,		10},		// Right Back
	{-2,		25},		// Right Half-Back
	{15,		-23},		// Left Mid
	{20,		0},			// Centre Mid
	{15,		23},		// Right Mid
	{30,		-10},		// Left Forward
	{30,		10},		// Right Forward
	
};

#endif _FORMATIONS_H
