/*
 * Author: Kostas Kostiadis
 * Description: Contains all the implementations for the agent's goal keeper play style
 * Created: 17/3/99
 * Last modified: 24/7/99
 */

//#include <stdlib.h>
#include <unistd.h>
#include <iostream.h>
#include "../Agent_Classes/CBall.H"
#include "../Agent_Classes/CPlayer.H"
#include "../Agent_Classes/CGoal.H"
#include "../Agent_Classes/CBehaviours.H"

/*
	The play mode IDs have the follows format:
		0 indicates before_kick_off
		Positive numbers indicate event for my side
		(i.e. corner_kick_l if I am left)
		Negative numbers indicate event for enemy side
		(i.e. corner_kick_l if I am right)
		The IDs for each mode are the same
		(i.e. if 1 indicates kick_off_? then
		-1 indicates also kick_off_?) with the sign
		determining if the event if for or against
		my team.
		
		These IDs are as follows:
			0:	before_kick_off
			1:	kick_off
			2:	kick_in
			3:	corner_kick
			4:	goal_kick
			5:	free_kick
			6:	offside
			
			7:	foul_?_UNum		// However it is foul_? without UNum !!!
			8:	goal_?_Point
			9:	goalie_catch_ball
			
		And then we have the modes that are only positive
		since they don't depend on the side.  These are:
		
			20:	play_on
			21:	half_time
			22:	time_over
			23: time_up_without_a_team
			24:	time_extended
			25:	drop_ball
		
*/

/*
	The positioning behaviours (Devensive/OffensivePosition) are
	assuming that we can see the ball
*/

// PLAYASGOALKEEPER ///////////////////////////////////////////////////////
void CBehaviours::PlayAsGoalKeeper(int PreviousPlayMode, int PlayMode)
{
/*
const CPlayer*const* pfa = M2BReadPlayerArray(0, 1);	// Get pointer to close friendly player data
const CPlayer*const* pea = M2BReadPlayerArray(0, 0);	// Get pointer to close enemy player data
const CPlayer* DTCand=0;
*/
CBall* pBall = M2BReadNonConstBall();	// Get ball data
const float GBFacing = GetBFacing();	// Store global body facing direction here
CVector GPos = GetGPos();				// Store global position here
int Time = GetTime();					// The current time
int closest, possession;				// Closer candidate and have possession test results
CVector isshot;							// Get is shot status
float CatchDir;							// The direction of the catch command
int i;									// for loop counter
int ChaseResult;						// Result of chase

if (PlayMode >= 20)							// Special modes
	{
	switch (PlayMode)
		{
		case 20:							// Play on
		
//////////////////////////////////////////// TESTING BEHAVIOURS /////////////////////////////////////
		/*
			if (GetTime() < 150)
				SetFormationID(-1);
			else if ((GetTime() > 150) && (GetTime() < 300))
				SetFormationID(0);
			else if (GetTime() > 300)
				SetFormationID(1);
		*/		
		//	MoveToPos(50);
		//	TurnNeck(0);
		//	ChangeView("normal", "high");
		//	SenseBody();
		//	Turn(5);
		//	cout << GetTime() << " GFacing = " << GFacing << endl;
		//	LookAround();
		//if (LookingAtBall()	!= 999)
		//	Turn(pBall->GetRDir());
		/*
		if (LookingAtBall()	!= 999)			// Look at ball and if found
			if (pBall->GetRMag() < 5)
				{
				if (ChaseBall(50))
					Kick(999, 0, 1.0);
				}
			else
				OffensivePosition();			// Go to best offensive position
		*/
		//	MoveToPos(0, 0, 100);
		//	while (!MoveToPos(-20, 0, 50)){};
		//	while (!MoveToPos(-30, 0, 100)){};
				
		//	while (!MoveToPosBW(-20, 0, -50)){};
		//	while (!MoveToPosBW(-30, 0, -100)){};				
		/*
			if (pBall->GetRMag() < m_Kickable)
				Kick(999, 0, 1.0);
			//sleep(1);
		*/
		/*	
			if (ChaseBall(m_Normal))
				{
				//BasicKick(100, 0);
				while (!SpinRound(180, 1)){if (!pBall->IsKickable()) break;}
				//while (!SpinRound(90, 1)){if (!pBall->IsKickable()) break;}
				}
			//sleep(1);
		*/
		/*
			if (ChaseBall(100))
				{
				ShootToGoal(3);
				//Kick(999,180,1.0);
				//LookAround();
				//if (!Pass(DTPass("57", 0), m_SoftPass))
				//	Turn(100.123);
				}
		*/
		/*
			if (LookingAtBall() != 999)
				{
				//Turn(pBall->GetRDir());
				closest = ClosestToBall(1);
				if (fabs(pBall->GetGY() < 25) && (pBall->GetGX() < -35) && (closest != 0))	// If closest and ball close
					{
					if (ChaseBall(100))
						{
						Catch(pBall->GetRDir());
						//if (!Pass(DTPass("0", 0)))
						//	ShootToGoal(2);
							//Turn(5);
						}
					}
				else
			
					MoveToPos(100);
				//cout << GetTime() << " Steps to intercept    : " << CyclesToIntercept(50.0, 100) << endl;
				//cout << GetTime() << " Steps for other to int: " << CyclesToIntercept(50.0, 100, 0, pfa[1]) << endl;
				}
		*/
		/*
			for (i=0; i<6; i++)
				{
				TurnNeck(1);
				}
			Turn(1);
		*/
		/*
		if (ChaseBall(m_Normal))
			{
			Catch(pBall->GetRDir());
			sleep(1);
			}
		*/
		/*
			if (ChaseBall(100))
				{
				//if (LookingAtGoal() != 999)
				//	{
					//Dribble(pGoal->GetGPos(), 50, 2);
					//Dribble(pGoal->GetGPos(), 100, 2, 60, 1, CVector(0,0));
					
					
				if (!CleverDribble(pGoal->GetGPos(), 50, 2))
					ClearBall(1);
					
					
					//if (pBall->GetGX() > 0)
					//	Kick(999, pGoal->GetRDir(), 1.0);
	
					//if (pGoal->GetRMag() < 20)
					//	ShootToGoal(1);
				//	}
				}
		*/
		/*
			if (pBall->IsKickable())
				{
				cout << GetTime() << " STARTED ===========================" << endl;
				cout << GetTime() << " FRIENDLY PLAYER DATA START --------" << endl;
				
				for (int kos=0; kos<5; kos++)
					pfa[kos]->Display();
				cout << GetTime() << " FRIENDLY PLAYER DATA END ----------" << endl;
				cout << GetTime() << " ENEMY PLAYER DATA START -----------" << endl;
				
				for (int kos2=0; kos2<6; kos2++)
					pea[kos2]->Display();
				cout << GetTime() << " ENEMY PLAYER DATA END -------------" << endl;
				
				srand(GetTime());
				int randpass = (rand() % 4) + 1;
				
				
				DTCand = DTPass("0", 0);
				
				if (DTCand == 0)
					{
					cout << "*** DTPass(0,0) returned NULL ***" << endl;
					}
				else
					{
					cout << " DTPass(0,0) is passing to: " << endl;
					DTCand->Display();
					Pass(DTCand);
					}
				
				
				switch (randpass)
					{
					case 1:
						cout << "*** PASSING TO PLAYER 2 ***" << endl;
						//cout << "*** AT Dist, Dir: " << pfa[1]->GetRDist() << ", " << pfa[1]->GetRDir() << endl;
						Pass(pfa[1]);
						break;
					case 2:
						cout << "*** PASSING TO PLAYER 3 ***" << endl;
						//cout << "*** AT Dist, Dir: " << pfa[2]->GetRDist() << ", " << pfa[2]->GetRDir() << endl;
						Pass(pfa[2]);
						break;
					case 3:
						cout << "*** PASSING TO PLAYER 4 ***" << endl;
						//cout << "*** AT Dist, Dir: " << pfa[3]->GetRDist() << ", " << pfa[3]->GetRDir() << endl;
						Pass(pfa[3]);
						break;
					case 4:
						cout << "*** PASSING TO PLAYER 5 ***" << endl;
						//cout << "*** AT Dist, Dir: " << pfa[4]->GetRDist() << ", " << pfa[4]->GetRDir() << endl;
						Pass(pfa[4]);
						break;
					default:
						cerr << "***REQUEST FOR ILLEGAL PASS... ***" << endl;
						break;
					}
				
				cout << GetTime() << " FINISHED ==========================" << endl;
				sleep(3);
				}		
		*/	
			
//////////////////////////////////////////////////////////////////////////////////////////////////////

			if (LookingAtBall() != 999)		// Always need to know where ball is
				{
				// Collect required data
				closest = ClosestToBall(1);			// Get closest status
				possession = HavePossession();		// Get possession status
				isshot = IsShot();					// Get shot status
					
				// IF BALL IN ENEMY HALF ///////////////////////////////////////////////////
				if (pBall->GetGX() > 0)		// If ball in enemy half
					{
					if (MoveToPos(m_Slow))	// If in position
						LookingAtBall(1);	// Just keep looking at the ball
					}
					
				// IF BALL WITHIN PENALTY BOX //////////////////////////////////////////////
				else if ((pBall->GetGX() < -35) && (fabs(pBall->GetGY()) < 20))	// else if ball in penalty box
					{
					CatchDir = NormaliseAngle(GBFacing + pBall->GetRDir());	// Calculate catch direction
					if (pBall->IsCatchable(GPos, CatchDir, Time))	// If ball is catchable
						{
						Catch(pBall->GetRDir());					// catch it
						}
					// If ball is kickable (not after it's just been caught)
					else if ((pBall->IsKickable()) && (P2BReadPlayMode(1) != 5) && (P2BReadPlayMode(1) != 9))
						{
						if (!Pass(DTPass("5", 1)))		// Try to pass and if that fails
							ClearBall(999);				// perform a defensive clearance
						}
					
					if ((isshot.GetMag() > 0) && (possession != -1))	// If there is an incoming shot
						{
						ChaseResult = GoalieChase(0);	// Chase it (passive)
						if (ChaseResult == 2)			// If catch possilbe
							{
							CatchDir = NormaliseAngle(GBFacing + pBall->GetRDir());	// Calculate catch direction
							Catch(pBall->GetRDir());					// catch it
							}
						else if (ChaseResult == 1)		// If kick possible
							{
							if (!Pass(DTPass("5", 1)))	// Try to pass and if that fails
								ClearBall(999);			// perform a defensive clearance
							}
						}
					
					else if (closest == 1)				// if the closest is me
						{
						if ((pBall->GetGX() < -42) && (fabs(pBall->GetGY() < 9)))	// If ball within a region
							{
							ChaseResult = GoalieChase(0);	// Chase it (passive)
							if (ChaseResult == 2)			// If catch possilbe
								{
								CatchDir = NormaliseAngle(GBFacing + pBall->GetRDir());	// Calculate catch direction
								Catch(pBall->GetRDir());					// catch it
								}
							else if (ChaseResult == 1)		// If kick possible
								{
								if (!Pass(DTPass("5", 1)))	// Try to pass and if that fails
									ClearBall(999);			// perform a defensive clearance
								}
							}
						
						else if (DefensivePosition())	// Go to best defensive position
							LookingAtBall(1);
						}	
						
					else if (closest == 0)				// if the closest is a teammate
						{
						if (DefensivePosition())		// Go to best defensive position
							LookingAtBall(1);
						}
						
					else								// else if closest is opponent
						{
						CatchDir = NormaliseAngle(GBFacing + pBall->GetRDir());	// Calculate catch direction
						if (pBall->IsCatchable(GPos, CatchDir, Time))	// If ball is catchable
							{
							Catch(pBall->GetRDir());					// catch it
							}
						// If ball is kickable (not after it's just been caught)
						else if ((pBall->IsKickable()) && (P2BReadPlayMode(1) != 5) && (P2BReadPlayMode(1) != 9))
							{
							if (!Pass(DTPass("5", 1)))					// Try to pass and if that fails
								ClearBall(999);							// perform a defensive clearance
							}
						
						if ((isshot.GetMag() > 0) && (possession != -1))	// If there is an incoming shot
							{
							ChaseResult = GoalieChase(0);	// Chase it (passive)
							if (ChaseResult == 2)			// If catch possilbe
								{
								CatchDir = NormaliseAngle(GBFacing + pBall->GetRDir());	// Calculate catch direction
								Catch(pBall->GetRDir());					// catch it
								}
							else if (ChaseResult == 1)		// If kick possible
								{
								if (!Pass(DTPass("5", 1)))	// Try to pass and if that fails
									ClearBall(999);			// perform a defensive clearance
								}
							}
						
						else if ((pBall->GetGX() < -48) && (fabs(pBall->GetGY() < 10)))	// If ball way to close
							{
							ChaseResult = GoalieChase(1);	// Chase it (active)
							if (ChaseResult == 2)			// If catch possilbe
								{
								CatchDir = NormaliseAngle(GBFacing + pBall->GetRDir());	// Calculate catch direction
								Catch(pBall->GetRDir());					// catch it
								}
							else if (ChaseResult == 1)		// If kick possible
								{
								if (!Pass(DTPass("5", 1)))	// Try to pass and if that fails
									ClearBall(999);			// perform a defensive clearance
								}
							}
						// else if he does not have possesion and ball close
						else if ((possession == 0) && (pBall->GetGX() < -42) && (fabs(pBall->GetGY() < 10)))
							{
							ChaseResult = GoalieChase(1);	// Chase it (active)
							if (ChaseResult == 2)			// If catch possilbe
								{
								CatchDir = NormaliseAngle(GBFacing + pBall->GetRDir());	// Calculate catch direction
								Catch(pBall->GetRDir());					// catch it
								}
							else if (ChaseResult == 1)		// If kick possible
								{
								if (!Pass(DTPass("5", 1)))	// Try to pass and if that fails
									ClearBall(999);			// perform a defensive clearance
								}
							}
						}
					}
					
				// IF BALL IN MY HALF BUT NOT IN PENALTY BOX ////////////////////////////////
				else								// else if ball in my half
					{
					if (isshot.GetMag() > 0)		// If there is an incoming shot
						{
						ChaseResult = GoalieChase(0);	// Chase it (passive)
						if (ChaseResult == 2)			// If catch possilbe
							{
							CatchDir = NormaliseAngle(GBFacing + pBall->GetRDir());	// Calculate catch direction
							Catch(pBall->GetRDir());					// catch it
							}
						else if (ChaseResult == 1)		// If kick possible
							{
							if (!Pass(DTPass("5", 1)))	// Try to pass and if that fails
								ClearBall(999);			// perform a defensive clearance
							}
						}
					
					else if (DefensivePosition())	// Go to best defensive position
						LookingAtBall(1);
					}
				}

			break;
		
		case 21:							// Half time
			SayBye();
			break;
		
		case 22:							// Time over
			SayBye();
			break;
			
		case 23:							// Time up without a team
			SayBye();
			break;
			
		case 24:							// Time extended
			SayBye();
			break;
			
		case 25:							// Drop ball
			LookingAtBall();
			break;
			
		default:
			cerr << "WARNING: CBehaviours: PlayAsGoalKeeper: What PlayMode ID is that - " << PlayMode << " -?" << endl;
			break;
		}
	}

else if ((PlayMode > 0) && (PlayMode < 20))		// My team has won something
	{
	switch (PlayMode)
		{
		case 1:									// Kick off
			// *** PREVIOUS MIGHT HAVE BEEN goal_ENEMYTEAM_Point
			// *** PREVIOUS MIGHT HAVE BEEN before_kick_off
			if (LookingAtBall() != 999)			// Look at ball and if found
				if (MoveToPos(m_Slow))			// Move to your home position
					LookingAtBall(1);
			break;
		
		case 2:									// Kick in
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (OffensivePosition())		// Go to best offensive position
					LookingAtBall(1);
			break;
		
		case 3:									// Corner Kick
			//Turn(80);
			
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (MoveToPos(m_Slow))			// Move to your home position
					LookingAtBall(1);
			
			break;
			
		case 4:									// Goal Kick
			if (MoveToPos(100))
				LookingAtBall(1);
			break;
			
		case 5:									// Free Kick
			// *** PREVIOUS MIGHT HAVE BEEN goalie_catch_ball_MYTEAM
			// *** PREVIOUS MIGHT HAVE BEEN offside_ENEMYTEAM
			// *** PREVIOUS MIGHT HAVE BEEN foul_ENEMYTEAM
			
			if (PreviousPlayMode == 9)			// If I did a catch
				{
				if (GPos.GetY() >= 0)
					{
					while ((GetTime() - Time) < 20)	// wait for defenders to position
						{
						Move(-50, 0);
						}
						
					Move(-37, -19);
					Move(-37, -19);
					usleep(100000);
					Kick(999, (-30-GetFacing()), 1.0);
					Kick(999, (-30-GetFacing()), 1.0);
					usleep(200000);
					}
				else
					{
					while ((GetTime() - Time) < 20)	// wait for defenders to position
						{
						Move(-50, 0);
						}
						
					Move(-37, 19);
					Move(-37, 19);
					usleep(100000);
					Kick(999, (30-GetFacing()), 1.0);
					Kick(999, (30-GetFacing()), 1.0);
					usleep(200000);
					}
					
				for (int i=0; i<20; i++)
					MoveToPos(100);
				}
			else
				{
				if (LookingAtBall()	!= 999)			// Look at ball and if found
					if (MoveToPos(m_Slow))			// Move to your home position
						LookingAtBall(1);
				}
			break;
			
		case 6:									// Offside
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (OffensivePosition())		// Go to best offensive position
					LookingAtBall(1);
			break;
			
		case 7:									// Foul
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (OffensivePosition())		// Go to best offensive position
					LookingAtBall(1);
			break;
			
		case 8:									// Goal
			InitialMove();
			Wait4NewVisual();
			LookingAtBall(1);
			break;
			
		case 9:									// Goalie catch ball
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				{
				InitialMove();					// Warp back to your home position
				LookingAtGoal(1);				// And face enemy goal
				}
			break;
			
		default:
			cerr << "WARNING: CBehaviours: PlayAsGoalKeeper: What PlayMode ID is that - " << PlayMode << " -?" << endl;
			break;
		}
	}
else if (PlayMode < 0)							// Enemy team has won something
	{
	switch (PlayMode)
		{
		case -1:								// Kick off
			// *** PREVIOUS MIGHT HAVE BEEN goal_MYTEAM_Point
			// *** PREVIOUS MIGHT HAVE BEEN before_kick_off
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (MoveToPos(m_Slow))			// Move to your home position
					LookingAtBall(1);
			break;
		
		case -2:								// Kick in
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (DefensivePosition())		// Go to best defensive position
					LookingAtBall(1);
			break;
		
		case -3:								// Corner Kick
			//LookingAtBall();
			
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (DefensivePosition())		// Go to best defensive position
					LookingAtBall(1);
			
			break;
			
		case -4:								// Goal Kick
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (MoveToPos(m_Slow))			// Move to your home position
					LookingAtBall(1);
			break;
			
		case -5:								// Free Kick
			// *** PREVIOUS MIGHT HAVE BEEN goalie_catch_ball_ENEMYTEAM
			// *** PREVIOUS MIGHT HAVE BEEN offside_MYTEAM
			// *** PREVIOUS MIGHT HAVE BEEN foul_MYTEAM
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (DefensivePosition())		// Go to best defensive position
					LookingAtBall(1);
			break;
			
		case -6:								// Offside
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (MoveToPos(m_Slow))			// Move to your home position
					LookingAtBall(1);
			break;
			
		case -7:								// Foul
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (DefensivePosition())		// Go to best defensive position
					LookingAtBall(1);
			break;
			
		case -8:								// Goal
			InitialMove();
			Wait4NewVisual();
			break;

		case -9:								// Goalie catch ball
			if (LookingAtBall()	!= 999)			// Look at ball and if found
				if (MoveToPos(m_Slow))			// Move to your home position
					LookingAtBall(1);
			break;
						
		default:
			cerr << "WARNING: CBehaviours: PlayAsGoalKeeper: What PlayMode ID is that - " << PlayMode << " -?" << endl;
			break;
		}
	}
	
else if (PlayMode == 0)						// Before kick off
	{
	if (PreviousPlayMode == 0)				// If just started or reconnected
		{
		InitialMove();
		Wait4NewVisual();
		LookingAtBall(1);
		}
	else									// else, it is half_time (or time_extended etc.)
		{
		SayBye();							// so say bye
		}
	}
	
else
	cerr << "WARNING: CBehaviours: PlayAsGoalKeeper: What PlayMode ID is that - " << PlayMode << " -?" << endl;
}
