// File    : MCIni.h
//
// Purpose : C++ Ini class
// Author  : Matthew Hunter
// Version : 0.01 (08 Jun 1999)
//           0.02 (24 Jun 1999)
//                Added getclassed functions

#ifndef MCIni_h
#define MCIni_h

#include "MCSettingList.h"
#include <iostream.h>

class MCIni {
 public:
  // Output
  friend ostream& operator<<(ostream&s,MCIni);

  void parse(MCString); // Examine the specified string and extract
                        // configuration options.
  void import(MCString);// Read the specified file and parse the contents
                        // for configuration options
  void export(MCString);// Write the current configuration options to the
                        // specified file.
  void insert(MCString,MCString,MCString);
  void insert(MCString,MCString,int);
  void insert(MCString,MCString,double);

  // get functions return the value for a given section, and a given
  // entry within that function. The third argument is the default
  // value to be returned if the desired entry does not exist.
  MCString get(MCString,MCString,MCString);
  int get(MCString,MCString,int);
  double get(MCString,MCString,double);

  // getclassed functions return the value from a given section and
  // a given classed entry for that function. The third argument is
  // the default to be returned if the desired entry does not exist
  // in the given class or any of the parent classes
  MCString getclassed(MCString,MCString,MCString);
  int getclassed(MCString,MCString,int);
  double getclassed(MCString,MCString,double);

  // Standard member functions
  // Standard constructors
  MCIni();  // Default constructor
  MCIni(const MCIni&); // Copy constructor

  // Standard operations
  MCIni& operator=(const MCIni&); // assignment

  // Destructor
  ~MCIni();
 private:
  MCSettingList *head;
  MCSettingList *find(MCString);
  MCString findsubclassed(MCString,MCString,MCString);
};

#endif



