// File    : MCMap.h
//
// Purpose : C++ Map class
// Author  : Matthew Hunter
// Version : 0.01 (08 Jun 1999)
//           0.02 (09 Jun 1999)
//                Now uses doubles for greater resolution.

#ifndef MCMap_h
#define MCMap_h

#include "MCString.h"
#include <iostream.h>

class MCMap {
 public:
  // Output
  friend ostream& operator<<(ostream&s,MCMap);

  MCMap operator+(const MCMap&) const;
  void exportraw(MCString);
  void export(MCString);

  void set(int x, int y, double value);
  double get(int x, int y);

  // Standard member functions
  // Standard constructors
  MCMap();  // Default constructor
  MCMap(const MCMap&); // Copy constructor
  MCMap(int,int); // Map of specified size

  // Standard operations
  MCMap& operator=(const MCMap&); // assignment

  // Destructor
  ~MCMap();
 protected:
  double *mapdata;
  int width;
  int height;
};

#endif



