// File    : MCTest.cpp
//
// Purpose : Test out the MC Library
// Author  : Matthew Hunter
// Version : 0.01 (24 May 1999)

#include "MCString.h"
#include "MCSettingList.h"
#include "MCIni.h"
#include "MCMap.h"
#include "MCXfig.h"

#include <iostream.h>


void MCStringTests(void) {
  cout << "MCTest: Starting MCString Tests\n";
  MCString a("abcd"), b("efgh");
  cout << "a = " << a << ", b = " << b << endl;
  cout << "length of a is " << a.length() << endl;
  MCString c;
  c = a + b;
  cout << "c = " << c << " (length = " << c.length() << ")" << endl;
  MCString d = "C String " + b;
  cout << "d = " << d << endl;
  a = b + " followed by a C string.";
  cout << "a now = " << a << endl;
  cout << "4th character of a = " << a[3] << endl;
  d = a;
  cout << "a = " << a << ", d = " << d << endl;
  a[3]='z';
  cout << "a now = " << a << endl;
  cout << "d now = " << d << endl;
  cout << "Result of a.compare(b) = " << a.compare(b) << endl;
  cout << "Result of b.compare(a) = " << b.compare(a) << endl;
  cout << "Result of a.compare(b,3) = " << a.compare(b,3) << endl;
  c = a;
  cout << "Result of a.compare(c) = " << a.compare(c) << endl;
  a = "abcd";
  b = "abcd";
  cout << "a = " << a << ", b = " << b << endl;
  cout << "Result of a.compare(b) = " << a.compare(b) << endl;
  a = a + b;
  c = a;
  cout << "a now = " << a << endl;
  cout << "Result of a.index('c') = " << a.index('c') << endl;
  cout << "Result of a.index('z') = " << a.index('z') << endl;
  cout << "Result of a.rindex('c') = " << a.rindex('c') << endl;
  d = a.left(a.rindex('c'));
  cout << "after 'd=a.left(a.rindex('c'))' d = " << d << endl;
  d = a.left(17);
  cout << "after 'd=a.left(17)' d = " << d << endl;
  cout << "a now = " << a << endl;
  d = a.shift(4);
  cout << "after 'd=a.shift(4)' d = " << d << endl;
  cout << "a now = " << a << endl;
  d = a.shift(4);
  cout << "after 'd=a.shift(4)' d = " << d << endl;
  cout << "a now = " << a << endl;
  d = a.shift(4);
  cout << "after 'd=a.shift(4)' d = " << d << endl;
  cout << "a now = " << a << endl;
  cout << "c now = " << c << endl;
  a = "aaaa";
  b = "aabb";
  c = "aabb";
  d = "bbbb";
  if (a>c) {
    cout << a << " > " << c << endl;
  } else {
    if (a==c) {
      cout << a << " == " << c << endl;
    } else {
      if (a<c) {
	cout << a << " < " << c << endl;
      } else {
	cout << "Oh dear.\n";
      }
    }
  }
  if (b>c) {
    cout << b << " > " << c << endl;
  } else {
    if (b==c) {
      cout << b << " == " << c << endl;
    } else {
      if (b<c) {
	cout << b << " < " << c << endl;
      } else {
	cout << "Oh dear.\n";
      }
    }
  }
  if (d>c) {
    cout << d << " > " << c << endl;
  } else {
    if (d==c) {
      cout << d << " == " << c << endl;
    } else {
      if (d<c) {
	cout << d << " < " << c << endl;
      } else {
	cout << "Oh dear.\n";
      }
    }
  }
  a+=b;
  cout << "a now = " << a << endl;
  a+=" Cool, a new C string.";
  cout << "a now = " << a << endl;
  const char *anothera=a;
  cout << "anothera = " << anothera << endl;

  MCString emptystring("");

  c=a;
  while(a!=emptystring) {
    b=a.tokenise(' ');
    cout << "    tokenise     token = " << b << endl;
    cout << "    tokenise remainder = " << a << endl;
    d=c.tailtokenise(' ');
    cout << "tailtokenise     token = " << d << endl;
    cout << "tailtokenise remainder = " << c << endl;
  }

  a = MCString(5);
  b = MCString(15.6);
  cout << "a = " << a << " and b = " << b << endl;
  cout << "sum is " << (double)a+(double)b << endl;

  MCString util("Mutil.h");
  MCString utilcontent = util.readFile();

  cout << "Contents of " << util << " are :\n";
  cout << utilcontent << endl;
  cout << "================================\n";

  cout << "MCTest: Completed MCString Tests\n";
}

void MCSettingListTests(void) {
  cout << "MCTest: Starting MCSettingList Tests\n";
  
  MCSettingList a,b;

  cout << "Created two new MCSettingLists.\n";
  cout << a << endl;
  cout << b << endl;

  a.insert("Test","1");

  cout << "Added \"Test=1\" to a.\n";
  cout << a << endl;
  cout << b << endl;

  b = a;
  a.insert("Additional","Text");

  cout << "b = a, then add \"Additional=Text\" to a.\n";
  cout << a << endl;
  cout << b << endl;

  b.insert("Test","15");
  a.insert("Extra","weird");
  a.insert("Ultra","fast");

  cout << "changed Test in b to 15, and add Extra and Ultra to a.\n";
  cout << a << endl;
  cout << b << endl;

  MCSettingList c(a);
  c.insert("Extra","onion rings");

  cout << "created c from a, changed Extra to onion rings.\n";
  cout << a << endl;
  cout << c << endl;

  a.insert("Class1:Class2:Class3:Home","15");
  a.insert("Class1:Class2:Target","16");
  a.insert("Class1:From","17");
  a.insert("To","18");

  cout << "Added classed entrys to a.\n";
  cout << a << endl;

  MCString found;
  double fd;
  found=a.get("Class1:Class2:Class3:Home","170");
  cout << "Contents of get(Class1:Class2:Class3:Home,170) = " << found << endl;
  found=a.getclassed("Class1:Class2:Class3:Home","170");
  cout << "Contents of getclassed(Class1:Class2:Class3:Home,170) = ";
  cout << found << endl;
  found=a.getclassed("Class1:Class2:Class3:Target","170");
  cout << "Contents of getclassed(Class1:Class2:Class3:Target,170) = ";
  cout << found << endl;
  found=a.getclassed("Class1:Class2:Class3:From","170");
  cout << "Contents of getclassed(Class1:Class2:Class3:From,170) = ";
  cout << found << endl;
  found=a.getclassed("Class1:Class2:Class3:To","170");
  cout << "Contents of getclassed(Class1:Class2:Class3:To,170) = ";
  cout << found << endl;
  found=a.getclassed("Class1:Class2:Class3:NotMe","170");
  fd = a.getclassed("Class1:Class2:Class3:NotMe",170.9);
  cout << "Contents of getclassed(Class1:Class2:Class3:NotMe,170) = ";
  cout << found << endl;
  cout << "Contents of getclassed(Class1:Class2:Class3:NotMe,170.9) = ";
  cout << fd << endl;

  cout << "MCTest: Completed MCSettingList Tests\n";
}

void MCIniTests() {
  cout << "MCTest: Starting MCIni Tests\n";

  MCIni a,b;

  cout << "created two MCIni objects \n";
  cout << "a = \n" << a << endl;
  cout << "b = \n" << b << endl;

  a.insert("Group1","Item1","Value1");
  a.insert("Group1","Item2","Value1");
  a.insert("Group2","Item1","Value4");
  a.insert("Group3","Item1","Value1");

  cout << "a = \n" << a << endl;
  cout << "b = \n" << b << endl;

  b = a;

  a.insert("Alpha","amount",5);
  a.insert("Beta","amount",17);
  a.insert("Group1","Item1","Value15");

  cout << "a = \n" << a << endl;
  cout << "b = \n" << b << endl;

  cout << "Alpha.amount + Beta.amount = ";
  cout << a.get("Alpha","amount",0)+a.get("Beta","amount",0);
  cout << endl;

  MCString inifile("Test.ini");
  MCString iniout("TestOut.ini");

  a.import(inifile);
  cout << "a = \n" << a << endl;

  a.export(iniout);

  cout << "MCTest: Completed MCIni Tests\n";
}

void MCMapTests(void) {
  cout << "MCTest: Starting MCMap Tests\n";

  MCMap small(4,4);

  cout << small;

  small.export(MCString("small.ppm"));

  MCMap greyscale(128,128);
  MCMap gradient(128,128);
  for(int i=0;i<128;i++) {
    for(int j=0;j<128;j++) {
      greyscale.set(j,i,j+i);
      gradient.set(j,i,127-j);
    }
  }

  MCMap sum;

  sum = greyscale+small;
  sum = greyscale+gradient;
  cout << "Done sum = greyscale + gradient\n";

  greyscale.export(MCString("greyscale.ppm"));
  gradient.export(MCString("gradient.ppm"));
  sum.export(MCString("sum.ppm"));

  cout << "MCTest: Completed MCMap Tests\n";
}

void MCXfigTests(void) {
  cout << "MCTest: Starting MCXfig Tests\n";

  MCXfig boxes("boxes.fig");

  boxes.drawBox(2.0,2.0,8.0,6.0);
  boxes.drawCircle(10.0,12.0,5.0);
  boxes.setThickness(30);
  boxes.setRed();
  boxes.setFill();
  boxes.setGreen();
  boxes.drawBox(10.0,2.0,16.0,6.0);
  boxes.setThickness(1);
  boxes.setDefault();
  boxes.setFill();
  boxes.setArrowHeadOn();
  boxes.setDashedLine();
  boxes.drawLine(5.0,7.0,15.0,17.0);
  boxes.setArrowHeadOff();
  boxes.setArrowTailOn();
  boxes.setDottedLine();
  boxes.drawLine(15.0,7.0,5.0,17.0);
  boxes.setFontSize(24.0);
  boxes.drawText("This is a test",15.0,7.0,20.0,2.0);
  boxes.setFontCourier();
  boxes.setBoldOn();
  boxes.drawText("This is another test",15.0,9.0,20.0,2.0);

  MCXfig pitch("pitch.fig");

  pitch.setScale(0.2); // 1/5 replica
  pitch.setOrigin(60,40);
  pitch.setDepth(200);
  pitch.drawBox(-60,-40, 60,40);
  pitch.setGreen();
  pitch.setFill();
  pitch.drawBox(-54,-35,54,35);

  pitch.setDepth(150);
  pitch.setDefault();
  pitch.setFill();
  pitch.setWhite();
  pitch.setThickness(4);
  pitch.drawBox(-52.5,-34.0,52.5,34.0);
  pitch.drawBox(-52.5,-20.0,-35.0,20.0);
  pitch.drawBox(35.0,-20.0,52.5,20.0);
  pitch.drawLine(0.0,-34,0,34);
  pitch.drawCircle(0.0,0.0,10.0);

  cout << "MCTest: Completed MCXfig Tests\n";
}

int main() {
  cout << "MCTest: Starting tests\n";

  MCStringTests();
  MCSettingListTests();
  MCIniTests();
  MCMapTests();
  MCXfigTests();

  cout << "MCTest: Completed tests\n";
  return 0;
}





