// File    : MCPLBallTrackerPos.h
//
// Purpose : C++ PLBallTrackerPos class
// Author  : Matthew Hunter
// Version : 0.01 (13 Jul 1999)
//                Derived from MCPLMarkerPos.h


#ifndef MCPLBALLTRACKERPOS_h
#define MCPLBALLTRACLERPOS_h

// Other PosLib Includes
#include "MCPLpoint.h"
#include "MCPLStatus.h"
#include "MCPLTrackerPos.h"
#include "MCPLPitchFig.h"

// MCLib includes
#include "MCExemplar.h"
#include "MCString.h"
#include "MCIni.h"

#include <iostream.h>

class MCPLBallTrackerPos: public MCPLTrackerPos {
 public:
  // Exemplar member functions
  MCString ident(void);
  void diagram(void);

  // Find the best tracking position based on the status
  point findposition(MCPLStatus *);

  // External functions, provide the positioning facilities
  MCPLPositioner *make(MCString,MCString,MCString,MCIni&,MCPLPositioner*);

  // Constructor for using the specified name and options.
  // Note that it is not necessary for the name to match the name
  // of the positioner being constructed.
  MCPLBallTrackerPos(MCString,MCString,MCString,MCIni&,MCPLPositioner*);

  // Create a prototype MCPL positioner
  // This constructor should never be invoked from a
  // program directly, use the 'positioner' variable
  // exported below to create instances.
  MCPLBallTrackerPos(MCExemplar); 

  // Standard member functions
  // Standard constructors
  MCPLBallTrackerPos();  // Default constructor
  MCPLBallTrackerPos(const MCPLBallTrackerPos&); // Copy constructor

  // Standard operations
  MCPLBallTrackerPos& operator=(const MCPLBallTrackerPos&); // assignment

  // Destructor
  ~MCPLBallTrackerPos();
 private:
 protected:
};

#endif



