// File    : MCPLFixedPos.h
//
// Purpose : C++ PLFixedPos class
// Author  : Matthew Hunter
// Version : 0.01 (23 Jun 1999)
//           0.02 (12 Jul 1999)
//                Modifications to make use of the new features of
//                MCPLPositioner, including:
//                Revision of make to take extra arguments.
//                Revision of constructor to take extra arguments.
//                Addition of ident and diagram functions.

#ifndef MCPLFIXEDPOS_h
#define MCPLFIXEDPOS_h

// Other PosLib Includes
#include "MCPLpoint.h"
#include "MCPLStatus.h"
#include "MCPLPositioner.h"

// MCLib includes
#include "MCExemplar.h"
#include "MCString.h"
#include "MCIni.h"

#include <iostream.h>

class MCPLFixedPos: public MCPLPositioner {
 public:
  // Output
  friend ostream& operator<<(ostream&s,MCPLPositioner);
  void display(ostream&s);

  // Exemplar member functions

  MCString ident(void);
  void diagram(void);

  // External functions, provide the positioning facilities

  MCPLPositioner *make(MCString,
		       MCString,
		       MCString,
		       MCIni&,
		       MCPLPositioner*);

  // Constructor for using the specified name and options.
  // Note that it is not necessary for the name to match the name
  // of the positioner being constructed.
  MCPLFixedPos(MCString,MCString,MCString,MCIni&,MCPLPositioner*);

  // Create a prototype MCPL positioner
  // This constructor should never be invoked from a
  // program directly, use the 'positioner' variable
  // exported below to create instances.
  MCPLFixedPos(MCExemplar); 

  // Standard member functions
  // Standard constructors
  MCPLFixedPos();  // Default constructor
  MCPLFixedPos(const MCPLFixedPos&); // Copy constructor

  // Standard operations
  MCPLFixedPos& operator=(const MCPLFixedPos&); // assignment

  // Destructor
  ~MCPLFixedPos();
 private:
 protected:
};

#endif



