// File    : MCPLPitchFig.cpp
//
// Purpose : C++ Pitch Figure class
// Author  : Matthew Hunter
// Version : 0.01 (6 Jul 1999)
//           0.02 (14 Jul 1999)
//                Minor corrections.

#include "MCPLPitchFig.h"
#include "MCString.h"
#include <iostream.h>
#include <stdio.h>

// Standard member functions
MCPLPitchFig::MCPLPitchFig(MCString file) :
  MCXfig(file) {
  drawPitch();
}

// Objects
void MCPLPitchFig::drawPitch(void) {
  setScale(0.2); // 1/5 replica
  setOrigin(60,40); // Move diagram onto page
  setDepth(200); // Put pitch in background
  drawBox(-60,-40, 60,40); // Border
  setGreen();  
  setFill();
  drawBox(-54,-35,54,35); // Grass

  setDepth(190); // Put pitch markings on top of grass
  setDefault();
  setFill();
  setWhite();
  setThickness(4);
  drawBox(-52.5,-34.0,52.5,34.0); // Boundary
  drawBox(-52.5,-20.0,-35.0,20.0); // Home penalty area
  drawBox(35.0,-20.0,52.5,20.0); // Opponent penalty area
  drawLine(0.0,-34,0,34); // Centre line
  drawCircle(0.0,0.0,10.0); // Centre circle

  // Goal posts
  setBlack();
  setFill();
  drawBox(-54.0,-7.32,-52.5,7.32);
  drawBox( 52.5,-7.32, 54.0,7.32);
  setDepth(100);
}

void MCPLPitchFig::drawPlayer(float x, float y) {
  setDepth(150);
  setThickness(1);
  drawCircle(x,y,0.8);
  setDepth(100);
}

void MCPLPitchFig::drawTeammate(float x, float y) {
  setRed();
  setFill();
  drawPlayer(x,y);
}

void MCPLPitchFig::drawOpponent(float x, float y) {
  setBlue();
  setFill();
  drawPlayer(x,y);
}

void MCPLPitchFig::drawBall(float x, float y) {
  setDepth(50);
  setBlack();
  setFill();
  setWhite();
  setThickness(2);
  drawCircle(x,y,0.5);
  setDepth(100);
  setThickness(1);
  setDefault();
  setFill();
}

// Standard constructors
MCPLPitchFig::MCPLPitchFig() :
  MCXfig() {
}

MCPLPitchFig::MCPLPitchFig(const MCPLPitchFig&) {
}

// Standard operations
MCPLPitchFig& MCPLPitchFig::operator=(const MCPLPitchFig&) {
}

// Destructor
MCPLPitchFig::~MCPLPitchFig() {
}




