// File    : MCPLStatus.cpp
//
// Purpose : Structure for holding current pitch status for the position
//           finding funtions.
// Author  : Matthew Hunter
// Version : 0.01 (20 Jun 1999)

#include "MCPLStatus.h"

ostream& operator<<(ostream&s,MCPLStatus dump) {
  int c;

  s << "MCPLStatus:" << endl;
  s << "Opponents goal = (" << dump.goal.X << ",";
  s << dump.goal.Y << ")." << endl;
  s << "  Players goal = (" << dump.owngoal.X << ",";
  s << dump.owngoal.Y << ")." << endl;
  s << " Ball location = (" << dump.ball.X << ",";
  s << dump.ball.Y << ")." << endl; 
  s << " There are " << dump.teamcount << " teammates at:" << endl;
  for(c=0;c<dump.teamcount;c++) {
    s << "    " << c << " = (" << dump.teammates[c].X << ",";
    s << dump.teammates[c].Y << ")." << endl;
  }
  s << " There are " << dump.opponentcount << " opponents at:" << endl;
  for(c=0;c<dump.opponentcount;c++) {
    s << "    " << c << " = (" << dump.opponents[c].X << ",";
    s << dump.opponents[c].Y << ")." << endl;
  }
  s << "Offside line is at " << dump.offside << "." << endl;
  return s;
}

MCPLStatus::MCPLStatus() {
  goal.X = 52.5;
  goal.Y = 0.0;
  owngoal.X = -52.5;
  owngoal.Y = 0.0;
  ball.X = 0.0;
  ball.Y = 0.0;
  teamcount=0;
  opponentcount=0;
  offside=0.0;
}

MCPLStatus::MCPLStatus(const MCPLStatus& source) {
  int c;

  goal = source.goal;
  owngoal = source.owngoal;
  ball = source.ball;
  if (source.teamcount>MCPLSTEAMMATES) {
    teamcount=MCPLSTEAMMATES;
  } else {
    teamcount=source.teamcount;
  }
  for(c=0;c<teamcount;c++) {
    teammates[c]=source.teammates[c];
  }
  if (source.teamcount>MCPLSOPPONENTS) {
    opponentcount=MCPLSOPPONENTS;
  } else {
    opponentcount=source.opponentcount;
  }
  for(c=0;c<opponentcount;c++) {
    opponents[c]=source.opponents[c];
  }
  offside=source.offside;
}

MCPLStatus& MCPLStatus::operator=(const MCPLStatus& source) {
  int c;

  goal = source.goal;
  owngoal = source.owngoal;
  ball = source.ball;
  if (source.teamcount>MCPLSTEAMMATES) {
    teamcount=MCPLSTEAMMATES;
  } else {
    teamcount=source.teamcount;
  }
  for(c=0;c<teamcount;c++) {
    teammates[c]=source.teammates[c];
  }
  if (source.teamcount>MCPLSOPPONENTS) {
    opponentcount=MCPLSOPPONENTS;
  } else {
    opponentcount=source.opponentcount;
  }
  for(c=0;c<opponentcount;c++) {
    opponents[c]=source.opponents[c];
  }
  offside=source.offside;

  return *this;
}




