// File    : MCPLStatus.h
//
// Purpose : Structure for holding current pitch status for the position
//           finding funtions.
// Author  : Matthew Hunter
// Version : 0.01 (16 Jun 1999)
//           0.02 ( 1 Jul 1999)
//                Modified to use #define to set number of teammates and
//                opponents
//           0.03 (20 Jul 1999)
//                Changed MCPLStatus from structure to public class
//                to take advantage of constructors etc.

#ifndef MCPLSTATUS_H
#define MCPLSTATUS_H

#include "MCPLpoint.h"

#ifndef BROKEN_STATUS
const int MCPLSTEAMMATES=10;
const int MCPLSOPPONENTS=11;
#else
const int MCPLSTEAMMATES=22;
const int MCPLSOPPONENTS=22;
#endif

class MCPLStatus {
 public:
  point goal;
  point owngoal;
  point ball;
  int teamcount;
  point teammates[MCPLSTEAMMATES];
  int opponentcount;
  point opponents[MCPLSOPPONENTS];
  MCPLPFLOAT offside;

  friend ostream& operator<<(ostream&,MCPLStatus);
  MCPLStatus(); // Constructor
  MCPLStatus(const MCPLStatus&); // Copy constructor
  MCPLStatus& operator=(const MCPLStatus&); // Assignment
};

#endif
