// File    : MCPLpoint.cpp
//
// Purpose : C++ point class
// Author  : Matthew Hunter
// Version : 0.01 (23 Jun 1999)
//                Added makepoint to convert a string in the format
//                "(x,y)" to a point value when x and y are valid
//                doubles.

#include "MCPLpoint.h"

point makepoint(MCString ps) {
  point retval;
  MCString strip;
  MCString x,y;

  y = ps; // Local copy of ps, so the callers copy is not destroyed
  strip = y.tokenise('('); // strip off leading '('
  x = y.tokenise(','); // break at the ','
  strip = y;
  y = strip.tokenise(')'); // Strip off the trailing ')'
  retval.X = (double)x;
  retval.Y = (double)y;

  return retval;
}

